Wallets

Understanding Wallets

As a stablecoin banking API, we provide the ability to instantly create stablecoin wallets and custody stablecoins in a simple way – without requiring external integrations.

Our wallet module lets customers store stablecoin balances and integrates seamlessly with our payment flows for fiat pay-ins and payouts, enabling fast, cost-effective, and reliable cross-border payment processing.

To create a wallet, you must first create a Customer.

Supported Blockchains and Stablecoins

Blockchain network

Stablecoins

Solana

USDC

Ethereum

USDC, USDT

Polygon

USDC, USDT

Tron

USDT

When interacting with Ethereum L1 and Ethereum L2 – like Ethereum network and Polygon network – note that the wallet addresses are identical.


How to create a Wallet

POST v1/wallets

This endpoint creates a wallet address associated with a customer. You can create multiple wallet addresses for each customer across supported blockchains.

In the request body, specify the customer_id, the wallet name, the target blockchain, and whether this is a customer-owned external wallet via is_external_wallet.

Request example for creating a wallet in solana:

curl https://api.unblockpay.com/v1/wallets \
  --request POST \
  --header 'Content-Type: application/json' \
  --header 'Authorization: YOUR_SECRET_TOKEN' \
  --data '{
    "customer_id": "019d7904-ec72-7754-b5f5-443defb20da0",
    "name": "Satoshi Wallet",
    "blockchain": "solana",
    "is_external_wallet": false
  }'

Response example:

{
  "id": "0196cc5a-3e53-700d-9fef-6ba253d9fb32",
  "name": "Satoshi Wallet",
  "blockchain": "solana",
  "address": "79jRumnFHUAf4wkutTq7231bFYJ494hUqhtJyLqS55fg",
  "is_external_wallet": false,
  "customer_id": "019d7904-ec72-7754-b5f5-443defb20da0",
  "created_at": "2025-05-14T01:13:09.276Z",
  "updated_at": "2025-05-14T01:13:09.276Z"
}

Wallets API endpoints

Here are the endpoints you'll need to create, list and manage wallets:

Method

Endpoint

Description

POST

/v1/wallets

Create a new wallet

GET

/v1/wallets

List all wallets

GET

/v1/wallets/{id}

Get details for a specific wallet

GET

/v1/wallets/{id}/balance

Get the balance of a specific wallet

GET

/v1/customers/{customer_id}/wallets

List all wallets for a specific customer

For the full schema and request/response details, see the API Reference.